
package net;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.applet.*;
import java.io.*;
import java.util.Date;
import gui.ClosableFrame;



public class CheckMail extends Applet {

  Socket socket;
  String serverHostName = null;
  PrintWriter     ps;
  InetAddress     rina, lina;
  int popPort        = 110;
  boolean standalone = false;

  CheckMailForm form;


 /**
  * Initialize the applet.
  */
  public void init()
  {
  	form = new CheckMailForm(this);
    	add (form);
    	form.setSize (300, 300);
    	setBackground(Color.blue);
    	if (serverHostName == null) serverHostName = getCodeBase().getHost();
    	System.out.println("ServerHostName="+serverHostName);
  }


 /**
  * Show status text to the user.
  */
  public void showStatus(String s) {

	System.out.println(s);
	if (standalone) return;
	super.showStatus(s);
  }

  BufferedReader buf_reader;

 /**
  * Perform check for e-mail.
  */
  public void checkForMail() throws IOException, NumberFormatException, Exception {

    showStatus("Checking for mail on " + serverHostName);

    socket = new Socket(serverHostName, popPort);    //  open a connection
    String rs;

    try {
        rina = socket.getInetAddress();
        lina = rina.getLocalHost();
                
        //
        //  Conversion of the PrintStream due to deprication.
        //     ps = new PrintStream(socket.getOutputStream());
        //
        //  Print values and objects to a Writer.
        //
        ps   = new PrintWriter(
        	socket.getOutputStream());
                
        //
        //  Conversion of the DataInputStream due to deprication.
        //    dis  = new DataInputStream(socket.getInputStream());
        //
        //  Use BufferedReader instead of DataInputStream.
        //
        buf_reader = new BufferedReader (
        	new InputStreamReader(socket.getInputStream()));

        //
        //  Check for messages
        //
	sendline ("USER " + form.getId());
	rs = sendline ("PASS " + form.getPswd());
	//if (rs.charAt(0) != '+') throw new Exception("Incorrect password");
	rs = sendline("STAT");
    }
    catch (Exception ex) {
	socket.close();
	throw ex;
    }

    // Close connection
    socket.close();

    // Parse result
    int r = 0;
    r = Integer.parseInt(rs.substring(4, rs.indexOf(" messages")));

    // Update result field
    form.resultField.setText(Integer.toString(r));
  }

 /**
  * Send a line of data to the server, and return the handshake.
  */
  String sendline(String data) throws IOException {

	System.out.println("sendline out:" + data);
	ps.println(data);
	ps.flush();

        //
        //  Conversion of the DataInputStream due to deprication.
        //
	// String s = dis.readLine();
        //
        String s = buf_reader.readLine();
	System.out.println("sendline in:" + s);
	return s;
  }


 /**
  * Main routine, for running as a standalone application.
  */
  public static void main(String args[]) {

	CheckMail ap = new CheckMail();
	ap.serverHostName = "mail.snet.net";
	ap.standalone = true;

	ClosableFrame fr = new ClosableFrame("CheckMail");
	ap.init();
	fr.add("Center", ap);
	fr.setSize(300, 300);
	fr.setVisible(true);
	ap.start();
  }
}



/**
 * Form for obtaining e-mail user id and password from the user.
 */
class CheckMailForm extends Panel implements ActionListener {

  CheckMail applet;

  // The form's elements...
  Label      idLabel;
  TextField  idField;
  Label      pswdLabel;
  TextField  pswdField;
  Button     button;
  Label      resultLabel;
  TextField  resultField;

 /**
  * The constructor.
  */
  public CheckMailForm(CheckMail ap) {

	applet = ap;
	setBackground(Color.blue);
	setLayout(new GridLayout(7, 1));

	// Instantiate all the elements, and add them to the form...
	add (button    = new Button("Check For Mail"));
        button.addActionListener (this);
	add (idLabel   = new Label("Id:"));
	add (idField   = new TextField(20));
	add (pswdLabel = new Label("Password:"));
	add (pswdField = new TextField(20));
	pswdField.setEchoChar('*');
	add (resultLabel = new Label("Messages Waiting:"));
	add (resultField = new TextField(6));
	resultField.setEditable(false);

	// Set the size of the form
	setSize(250, 250);
  }


 /**
  * Return the value of the ID field in the form.
  */
  public String getId() {
  	return idField.getText();
  }


 /**
  * Return the value of the password field in the form.
  */
  public String getPswd() {
	return pswdField.getText();
  }


  //
  //  Updated to the new Event model.
  //
  public void actionPerformed (ActionEvent e) {
  	
    if(e.getSource() == button) {

       	try  { applet.checkForMail(); }
        catch (Exception ex) {
          applet.showStatus("Error; unable to check for messages:\n  "+ex.toString());
          return;
        }
        applet.showStatus("Completed.");
    }
  }
}
